Loading...
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12# ^
13# |
14# +--< vmlinux.a
15# |
16# +--< $(KBUILD_VMLINUX_LIBS)
17# | +--< lib/lib.a + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
35is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
37}
38
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
43 printf " %-7s %s\n" "${1}" "${2}"
44}
45
46# Link of vmlinux
47# ${1} - output file
48# ${2}, ${3}, ... - optional extra .o files
49vmlinux_link()
50{
51 local output=${1}
52 local objs
53 local libs
54 local ld
55 local ldflags
56 local ldlibs
57
58 info LD ${output}
59
60 # skip output file argument
61 shift
62
63 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
64 # Use vmlinux.o instead of performing the slow LTO link again.
65 objs=vmlinux.o
66 libs=
67 else
68 objs=vmlinux.a
69 libs="${KBUILD_VMLINUX_LIBS}"
70 fi
71
72 if is_enabled CONFIG_MODULES; then
73 objs="${objs} .vmlinux.export.o"
74 fi
75
76 objs="${objs} init/version-timestamp.o"
77
78 if [ "${SRCARCH}" = "um" ]; then
79 wl=-Wl,
80 ld="${CC}"
81 ldflags="${CFLAGS_vmlinux}"
82 ldlibs="-lutil -lrt -lpthread"
83 else
84 wl=
85 ld="${LD}"
86 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
87 ldlibs=
88 fi
89
90 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
91
92 # The kallsyms linking does not need debug symbols included.
93 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
94 ldflags="${ldflags} ${wl}--strip-debug"
95 fi
96
97 if is_enabled CONFIG_VMLINUX_MAP; then
98 ldflags="${ldflags} ${wl}-Map=${output}.map"
99 fi
100
101 ${ld} ${ldflags} -o ${output} \
102 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
103 ${wl}--start-group ${libs} ${wl}--end-group \
104 $@ ${ldlibs}
105}
106
107# generate .BTF typeinfo from DWARF debuginfo
108# ${1} - vmlinux image
109# ${2} - file to dump raw BTF data into
110gen_btf()
111{
112 local pahole_ver
113
114 if ! [ -x "$(command -v ${PAHOLE})" ]; then
115 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
116 return 1
117 fi
118
119 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
120 if [ "${pahole_ver}" -lt "116" ]; then
121 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
122 return 1
123 fi
124
125 vmlinux_link ${1}
126
127 info "BTF" ${2}
128 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
129
130 # Create ${2} which contains just .BTF section but no symbols. Add
131 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132 # deletes all symbols including __start_BTF and __stop_BTF, which will
133 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
134 # objcopy warnings: "empty loadable segment detected at ..."
135 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136 --strip-all ${1} ${2} 2>/dev/null
137 # Change e_type to ET_REL so that it can be used to link final vmlinux.
138 # Unlike GNU ld, lld does not allow an ET_EXEC input.
139 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
140}
141
142# Create ${2} .S file with all symbols from the ${1} object file
143kallsyms()
144{
145 local kallsymopt;
146
147 if is_enabled CONFIG_KALLSYMS_ALL; then
148 kallsymopt="${kallsymopt} --all-symbols"
149 fi
150
151 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
152 kallsymopt="${kallsymopt} --absolute-percpu"
153 fi
154
155 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
156 kallsymopt="${kallsymopt} --base-relative"
157 fi
158
159 if is_enabled CONFIG_LTO_CLANG; then
160 kallsymopt="${kallsymopt} --lto-clang"
161 fi
162
163 info KSYMS ${2}
164 scripts/kallsyms ${kallsymopt} ${1} > ${2}
165}
166
167# Perform one step in kallsyms generation, including temporary linking of
168# vmlinux.
169kallsyms_step()
170{
171 kallsymso_prev=${kallsymso}
172 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
173 kallsymso=${kallsyms_vmlinux}.o
174 kallsyms_S=${kallsyms_vmlinux}.S
175
176 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
177 mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms
178 kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
179
180 info AS ${kallsyms_S}
181 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
182 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
183 -c -o ${kallsymso} ${kallsyms_S}
184}
185
186# Create map file with all symbols from ${1}
187# See mksymap for additional details
188mksysmap()
189{
190 info NM ${2}
191 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
192}
193
194sorttable()
195{
196 ${objtree}/scripts/sorttable ${1}
197}
198
199# Delete output files in case of error
200cleanup()
201{
202 rm -f .btf.*
203 rm -f System.map
204 rm -f vmlinux
205 rm -f vmlinux.map
206}
207
208# Use "make V=1" to debug this script
209case "${KBUILD_VERBOSE}" in
210*1*)
211 set -x
212 ;;
213esac
214
215if [ "$1" = "clean" ]; then
216 cleanup
217 exit 0
218fi
219
220${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
221
222btf_vmlinux_bin_o=""
223if is_enabled CONFIG_DEBUG_INFO_BTF; then
224 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
225 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
226 echo >&2 "Failed to generate BTF for vmlinux"
227 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
228 exit 1
229 fi
230fi
231
232kallsymso=""
233kallsymso_prev=""
234kallsyms_vmlinux=""
235if is_enabled CONFIG_KALLSYMS; then
236
237 # kallsyms support
238 # Generate section listing all symbols and add it into vmlinux
239 # It's a three step process:
240 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
241 # but __kallsyms is empty.
242 # Running kallsyms on that gives us .tmp_kallsyms1.o with
243 # the right size
244 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
245 # the right size, but due to the added section, some
246 # addresses have shifted.
247 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
248 # 3) That link may have expanded the kernel image enough that
249 # more linker branch stubs / trampolines had to be added, which
250 # introduces new names, which further expands kallsyms. Do another
251 # pass if that is the case. In theory it's possible this results
252 # in even more stubs, but unlikely.
253 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
254 # other bugs.
255 # 4) The correct ${kallsymso} is linked into the final vmlinux.
256 #
257 # a) Verify that the System.map from vmlinux matches the map from
258 # ${kallsymso}.
259
260 kallsyms_step 1
261 kallsyms_step 2
262
263 # step 3
264 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
265 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
266
267 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
268 kallsyms_step 3
269 fi
270fi
271
272vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
273
274# fill in BTF IDs
275if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
276 info BTFIDS vmlinux
277 ${RESOLVE_BTFIDS} vmlinux
278fi
279
280mksysmap vmlinux System.map
281
282if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
283 info SORTTAB vmlinux
284 if ! sorttable vmlinux; then
285 echo >&2 Failed to sort kernel tables
286 exit 1
287 fi
288fi
289
290# step a (see comment above)
291if is_enabled CONFIG_KALLSYMS; then
292 if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
293 echo >&2 Inconsistent kallsyms data
294 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
295 exit 1
296 fi
297fi
298
299# For fixdep
300echo "vmlinux: $0" > .vmlinux.d
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12# ^
13# |
14# +--< vmlinux.a
15# |
16# +--< $(KBUILD_VMLINUX_LIBS)
17# | +--< lib/lib.a + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
35is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
37}
38
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
43 printf " %-7s %s\n" "${1}" "${2}"
44}
45
46# Link of vmlinux
47# ${1} - output file
48vmlinux_link()
49{
50 local output=${1}
51 local objs
52 local libs
53 local ld
54 local ldflags
55 local ldlibs
56
57 info LD ${output}
58
59 # skip output file argument
60 shift
61
62 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
63 # Use vmlinux.o instead of performing the slow LTO link again.
64 objs=vmlinux.o
65 libs=
66 else
67 objs=vmlinux.a
68 libs="${KBUILD_VMLINUX_LIBS}"
69 fi
70
71 if is_enabled CONFIG_GENERIC_BUILTIN_DTB; then
72 objs="${objs} .builtin-dtbs.o"
73 fi
74
75 if is_enabled CONFIG_MODULES; then
76 objs="${objs} .vmlinux.export.o"
77 fi
78
79 objs="${objs} init/version-timestamp.o"
80
81 if [ "${SRCARCH}" = "um" ]; then
82 wl=-Wl,
83 ld="${CC}"
84 ldflags="${CFLAGS_vmlinux}"
85 ldlibs="-lutil -lrt -lpthread"
86 else
87 wl=
88 ld="${LD}"
89 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
90 ldlibs=
91 fi
92
93 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
94
95 # The kallsyms linking does not need debug symbols included.
96 if [ -n "${strip_debug}" ] ; then
97 ldflags="${ldflags} ${wl}--strip-debug"
98 fi
99
100 if is_enabled CONFIG_VMLINUX_MAP; then
101 ldflags="${ldflags} ${wl}-Map=${output}.map"
102 fi
103
104 ${ld} ${ldflags} -o ${output} \
105 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
106 ${wl}--start-group ${libs} ${wl}--end-group \
107 ${kallsymso} ${btf_vmlinux_bin_o} ${arch_vmlinux_o} ${ldlibs}
108}
109
110# generate .BTF typeinfo from DWARF debuginfo
111# ${1} - vmlinux image
112gen_btf()
113{
114 local btf_data=${1}.btf.o
115
116 info BTF "${btf_data}"
117 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
118
119 # Create ${btf_data} which contains just .BTF section but no symbols. Add
120 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
121 # deletes all symbols including __start_BTF and __stop_BTF, which will
122 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
123 # objcopy warnings: "empty loadable segment detected at ..."
124 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
125 --strip-all ${1} "${btf_data}" 2>/dev/null
126 # Change e_type to ET_REL so that it can be used to link final vmlinux.
127 # GNU ld 2.35+ and lld do not allow an ET_EXEC input.
128 if is_enabled CONFIG_CPU_BIG_ENDIAN; then
129 et_rel='\0\1'
130 else
131 et_rel='\1\0'
132 fi
133 printf "${et_rel}" | dd of="${btf_data}" conv=notrunc bs=1 seek=16 status=none
134
135 btf_vmlinux_bin_o=${btf_data}
136}
137
138# Create ${2}.o file with all symbols from the ${1} object file
139kallsyms()
140{
141 local kallsymopt;
142
143 if is_enabled CONFIG_KALLSYMS_ALL; then
144 kallsymopt="${kallsymopt} --all-symbols"
145 fi
146
147 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
148 kallsymopt="${kallsymopt} --absolute-percpu"
149 fi
150
151 info KSYMS "${2}.S"
152 scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
153
154 info AS "${2}.o"
155 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
156 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
157
158 kallsymso=${2}.o
159}
160
161# Perform kallsyms for the given temporary vmlinux.
162sysmap_and_kallsyms()
163{
164 mksysmap "${1}" "${1}.syms"
165 kallsyms "${1}.syms" "${1}.kallsyms"
166
167 kallsyms_sysmap=${1}.syms
168}
169
170# Create map file with all symbols from ${1}
171# See mksymap for additional details
172mksysmap()
173{
174 info NM ${2}
175 ${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
176}
177
178sorttable()
179{
180 ${objtree}/scripts/sorttable ${1}
181}
182
183cleanup()
184{
185 rm -f .btf.*
186 rm -f System.map
187 rm -f vmlinux
188 rm -f vmlinux.map
189}
190
191# Use "make V=1" to debug this script
192case "${KBUILD_VERBOSE}" in
193*1*)
194 set -x
195 ;;
196esac
197
198if [ "$1" = "clean" ]; then
199 cleanup
200 exit 0
201fi
202
203${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
204
205arch_vmlinux_o=
206if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
207 arch_vmlinux_o=arch/${SRCARCH}/tools/vmlinux.arch.o
208fi
209
210btf_vmlinux_bin_o=
211kallsymso=
212strip_debug=
213
214if is_enabled CONFIG_KALLSYMS; then
215 true > .tmp_vmlinux0.syms
216 kallsyms .tmp_vmlinux0.syms .tmp_vmlinux0.kallsyms
217fi
218
219if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
220
221 # The kallsyms linking does not need debug symbols, but the BTF does.
222 if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
223 strip_debug=1
224 fi
225
226 vmlinux_link .tmp_vmlinux1
227fi
228
229if is_enabled CONFIG_DEBUG_INFO_BTF; then
230 if ! gen_btf .tmp_vmlinux1; then
231 echo >&2 "Failed to generate BTF for vmlinux"
232 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
233 exit 1
234 fi
235fi
236
237if is_enabled CONFIG_KALLSYMS; then
238
239 # kallsyms support
240 # Generate section listing all symbols and add it into vmlinux
241 # It's a four step process:
242 # 0) Generate a dummy __kallsyms with empty symbol list.
243 # 1) Link .tmp_vmlinux1.kallsyms so it has all symbols and sections,
244 # with a dummy __kallsyms.
245 # Running kallsyms on that gives us .tmp_vmlinux1.kallsyms.o with
246 # the right size
247 # 2) Link .tmp_vmlinux2.kallsyms so it now has a __kallsyms section of
248 # the right size, but due to the added section, some
249 # addresses have shifted.
250 # From here, we generate a correct .tmp_vmlinux2.kallsyms.o
251 # 3) That link may have expanded the kernel image enough that
252 # more linker branch stubs / trampolines had to be added, which
253 # introduces new names, which further expands kallsyms. Do another
254 # pass if that is the case. In theory it's possible this results
255 # in even more stubs, but unlikely.
256 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
257 # other bugs.
258 # 4) The correct ${kallsymso} is linked into the final vmlinux.
259 #
260 # a) Verify that the System.map from vmlinux matches the map from
261 # ${kallsymso}.
262
263 # The kallsyms linking does not need debug symbols included.
264 strip_debug=1
265
266 sysmap_and_kallsyms .tmp_vmlinux1
267 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
268
269 vmlinux_link .tmp_vmlinux2
270 sysmap_and_kallsyms .tmp_vmlinux2
271 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
272
273 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
274 vmlinux_link .tmp_vmlinux3
275 sysmap_and_kallsyms .tmp_vmlinux3
276 fi
277fi
278
279strip_debug=
280
281vmlinux_link vmlinux
282
283# fill in BTF IDs
284if is_enabled CONFIG_DEBUG_INFO_BTF; then
285 info BTFIDS vmlinux
286 ${RESOLVE_BTFIDS} vmlinux
287fi
288
289mksysmap vmlinux System.map
290
291if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
292 info SORTTAB vmlinux
293 if ! sorttable vmlinux; then
294 echo >&2 Failed to sort kernel tables
295 exit 1
296 fi
297fi
298
299# step a (see comment above)
300if is_enabled CONFIG_KALLSYMS; then
301 if ! cmp -s System.map "${kallsyms_sysmap}"; then
302 echo >&2 Inconsistent kallsyms data
303 echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
304 exit 1
305 fi
306fi
307
308# For fixdep
309echo "vmlinux: $0" > .vmlinux.d